<?php
//ini_set('display_errors', 1);
//ini_set("log_errors", 1);
//error_reporting(1);
ini_set("error_log", "php-error.log");

/* this file handles some actions that are most of the time requested 
   by the javascript portion of the FE */

/* since most of the time the file is loaded sandalonely, so we have to 
   include the initializing files if they haven't been included already */
require_once "vendor/simple_html_dom.php";
require_once "settings.php";
require_once "include/init.php";
require_once "include/functions.php";

$srv = $user_settings['instance'];

if (isset($_GET['action']) && $_GET['action'] == "settings"){
	//file_put_contents("settings.txt",var_export($_GET,true));
	
	foreach($_GET as $key => $value){
		switch($key){
			case "explicit":
				$user_settings['explicit'] = htmlentities($value);
				break;
				
			case "emoji":
				$user_settings['emoji'] = intval($value);
				break;
				
			case "text":
				$user_settings['text'] = ($value == "on" ? "on" : "off");
				break;
				
			case "attach":
				$user_settings['attach'] = ($value == "on" ? "on" : "off");
				break;
				
			case "replies":
				$user_settings['replies'] = ($value == "on" ? "on" : "off");
				break;
				
			case "setreblog":
				$user_settings['reblog'] = ($value == "on" ? "on" : "off");
				break;

			case "videoloop":
				$user_settings['videoloop'] = ($value == "on" ? "on" : "off");
				break;	
			
			case "theme":
				$user_settings['theme'] = sanitize($value);
				break;	
			
			case "instance":
				if (!isset($_COOKIE['token'])){
					$user_settings['instance'] = htmlentities($value);
				}
				break;
				
			case "fg":
				$theme['fg'] = sanitize($value);
				break;
				
			case "bg":
				$theme['bg'] = sanitize($value);
				break;
				
			case "tx":
				$theme['tx'] = sanitize($value);
				break;
			
			case "lc":
				$theme['lc'] = sanitize($value);
				break;

			case "bc":
				$theme['bc'] = sanitize($value);
				break;

			case "br":
				$theme['br'] = sanitize($value);
				break;

			case "bw":
				$theme['bw'] = sanitize($value);
				break;					
		}
	}
	setrawcookie("user_settings",base64_encode(json_encode($user_settings)),time()+60*60*24*30,'/'); 
	setrawcookie("theme",base64_encode(json_encode($theme)),time()+60*60*24*30,'/'); 
	die();
}


$thread = (isset($_GET['thread']) ? htmlentities($_GET['thread']) : false);
$mode = (isset($_GET['mode']) ? htmlentities($_GET['mode']) : false);
$ajax = (isset($_GET['a']) ? true : false);

foreach($_GET as $key => $value){
	switch($key){
		case "fav":
			$result = favourite($value,($mode === 'on' ? true : false));
			if ($ajax){
				echo $result;
				die();
			} else {
				header("Location: ?thread=".$value);
			}
			break;
			
		case "reblog":
			$result =reblog($value,($mode === 'on' ? true : false));
			if ($ajax){
				echo $result;
				die();
			} else {
				header("Location: ?thread=".$value);
			}
			break;
			
		case "mute":
			if($thread){
				$rel = api_post("statuses/".htmlentities($value)."/".($mode === 'true' ? "" : "un")."mute",array());
				echo (isset($rel[0]['muting']) ? "1" : "0" );
			} else {
				$rel = api_post("accounts/".htmlentities($value)."/".($mode === 'true' ? "" : "un")."mute",array());
				echo (isset($rel[0]['muting']) ? "1" : "0" );
			}
			die();
			break;
			
		case "list":
			if($mode === 'true'){
				$rel = api_post("lists/".htmlentities($value)."/accounts?account_ids[]=".$_GET['user'],array());
				var_dump($rel);
			} else {
				$rel = api_delete("lists/".htmlentities($value)."/accounts?account_ids[]=".$_GET['user'],array());
				var_dump($rel);
			}
			die();
			break;
			
		case "block":
			$rel = api_post("accounts/".htmlentities($value)."/".($mode === 'true' ? "" : "un")."block",array());
			echo (isset($rel[0]['blocking']) ? "1" : "0" );
			die();
			break;
	
		case "bookmark":
			$status = api_get("statuses/".htmlentities($value));
			$rel = api_post("statuses/".htmlentities($value)."/".($status['bookmarked'] == 'true' ? "un" : "")."bookmark",array());
			die();
			break;					
			
		case "notif":
			
			echo getnotif(intval($value),(isset($_GET['max']) ? true : false));
			die();
			break;
			
		case "delete":
			echo delpost(htmlentities($value));
			die();
			break;
			
		case "replies":
			$since = (isset($_GET['since']) ? htmlentities($_GET['since']) : false);
			foreach(getreplies(htmlentities($value),$since) as $elem){
				echo render_reply($elem['content']);
			}
			die();
			break;
			
		case "notes":
			$notes = getnotes($value);
			foreach ($notes as $note){
				echo "<div id='".$note[1]['id']."'>
						<a href='?user=".$note[1]['id']."' class='ldr' title='".$note[1]['acct']."'>
							<div class='nte' style='background-image:url(".$note[1]['avatar'].");'>
								<div class='nte_type' style='background-color:".($note[0] == "fav" ? "red" : "green")."'><span>".($note[0] == "fav" ? "&#xe802;" : "&#xe826;")."</span></div>
							</div>
						</a>
					  </div>";	
			}
			die();
			break;
			
		case "follow":
			$rel = api_post("accounts/".htmlentities($value)."/follow",array());
			echo ($rel['following'] == true || $rel['requested'] == true ? "1" : "0" );
			die();
			break;
			
		case "unfollow":
			$rel = api_post("accounts/".htmlentities($value)."/unfollow",array());
			echo ($rel['following'] == false ? "1" : "0" );
			die();
			break;
			
		case "nsfw":
			if(in_array($value,$user_settings['nsfw'])){
				$key = array_search($value, $user_settings['nsfw']);
				unset($user_settings['nsfw'][$key]);
				setrawcookie("user_settings",base64_encode(json_encode($user_settings)),time()+60*60*24*30,'/'); 
			} else {
				$user_settings['nsfw'][] = htmlentities($value);
				setrawcookie("user_settings",base64_encode(json_encode($user_settings)),time()+60*60*24*30,'/'); 
			}
			echo "1";
			die();
			break;
			
		case "hide":
			if(!isset($user_settings['hide'])|| !is_array($user_settings['hide'])){
				$user_settings['hide'] = array();
			}
			if(in_array($value,$user_settings['hide'])){
				$key = array_search($value, $user_settings['hide']);
				unset($user_settings['hide'][$key]);
				setrawcookie("user_settings",base64_encode(json_encode($user_settings)),time()+60*60*24*30,'/'); 
			} else {
				$user_settings['hide'][] = htmlentities($value);
				setrawcookie("user_settings",base64_encode(json_encode($user_settings)),time()+60*60*24*30,'/'); 
			}
			echo "1";
			die();
			break;
			
		case "userinfo":
			$info = api_get("accounts/".htmlentities($value));
			$rel = api_get("accounts/relationships?id=".htmlentities($value));
			$image=imagecreatefromstring(file_get_contents($info['avatar']));
			$thumb=imagecreatetruecolor(1,1);
			imagecopyresampled($thumb,$image,0,0,0,0,1,1,imagesx($image),imagesy($image));
			$mainColor=strtoupper(dechex(imagecolorat($thumb,0,0)));
			
			echo "<div class='userinfo_he' style='background-color:#$mainColor; background-size:cover; background-image:url(" . $info['header_static'] . ");'>
					<span style='margin:5px; display:inline-block;'>
						<a href='".$info['url']."' target='_blank' class='external' style='font-weight:bold; font-size:13px; text-decoration:none; color: white; text-shadow: -1px -1px 0 #000,  1px -1px 0 #000, -1px 1px 0 #000, 1px 1px 0 #000;'>".$info['acct']."</a>
					</span>
				  </div>
					<div class='userinfo_co'>
						<div class='avatar' style='position: absolute; left:35%; top:-60px; display:inline-block; margin:0px; background-color:white; background-image:url(" . $info['avatar'] . "); text-align:center; border:3px solid white; border-radius:10px; clear:both;'></div>
						<div style='font-weight:bold; padding-top:30px; display:block;'><a href='?user=".$info['id']."' class='link ldr' style='font-size:15px;'>".emojify($info['display_name'],$info['emojis'],20)."</a></div><br>
						<div style='font-weight:normal; font-size:12px; line-height:12px;'>".emojify($info['note'],$info['emojis'],20)."</div><br>
						<span style='width:290; height:30px; display:block; margin-top:10px;'>
							".($logedin ? "<span id='".$info['id']."' class='profileButton ".(($rel[0]['following'] || $rel[0]['requested']) ? "unfollow" : "follow" )."'>".($rel[0]['following'] || $rel[0]['requested'] ? "Following" : "Follow" )."</span>" : "")."
							<span id='".$info['id']."' class='profileButton ".(in_array($info['id'],$user_settings['nsfw']) ? "unnsfw" : "nsfw" )."'>".(in_array($info['id'],$user_settings['nsfw']) ? "NSFW <span class='fontello'>&#xf205;</span>" : "NSFW <span class='fontello'>&#xf204;</span>" )."</span>
						</span>
					</div>
				  ";
			die();
			break;
			
	case "previewpost":
			$post = api_get("statuses/".htmlentities($value));
			echo "<div class='notifContents' style='max-width:none;'>
				<div style='flex: 0 0 60px; background-size:cover; background-image:url(".$post['account']['avatar']."); border-radius:5px;'></div>
				<div style='flex: 1; padding-left:5px; padding-right:5px; word-break: break-all; overflow:hidden;'>
					<span><span style='font-size:12px; font-weight:bold;'><a class='link' style='font-size:12px;' href='?user=9hwsQhjN9oox1iSfK4'>".emojify($post['account']['display_name'],$post['account']['emojis'],20)."</a></span></span>
					<a style='text-decoration:none;' class='ldr' href='?thread=9nngbBWBRHvILwEoF6' target='_blank'><span style='display:block; opacity:1; font-size:10px; line-height:12px;'>".emojify(strip_tags($post['content'],'<br>'),$post['emojis'],20)."</span></a>
					</div>
					".(!empty($post['media_attachments']) ? "<div style='flex: 0 0 60px; background-size:cover; background-image:url(".$post['media_attachments'][0]['url'].");'></div>" :"")."
			</div>";
			die();
			break;
	
	
	case "themefile":
		//echo $value;
			echo themes("get",$value);
			die();
			break;
			
	case "emoji":
		echo emoji_list(sanitize($value));
		//die();
		break;
	}
}


if(isset($_POST['status'])){
	
	if(isset($_POST['scope'])){
		switch($_POST['scope']){
			case "1":
			$scope = "public";
			break;
			
			case "2":
			$scope = "unlisted";
			break;
			
			case "3":
			$scope = "private";
			break;
			
			case "4":
			$scope = "direct";
			break;
		}
	} else {
		if (isset($_POST['thread'])){
			$result = api_get("statuses/".htmlentities($_POST['thread']));
			$scope = $result['visibility'];
		} else {
			$scope = "public";
		}
	}
	
	$uploaded = (empty($_POST['uploaded']) ? array() : explode("|",$_POST['uploaded']));
	$reply = json_decode(sendpost(trim($_POST['status']),$uploaded,$_POST['thread'],false,$scope,(isset($_POST['sensitive']) ? $_POST['sensitive'] : false),(isset($_POST['spoiler']) && $_POST['spoiler'] != 'Title (optional)' ? $_POST['spoiler'] : false)),true);
	echo render_reply($reply);
	die();
}

